OGRE: Ogre::Camera Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Camera Class Reference
Core » Scene

A viewpoint from which the scene will be rendered. More...

`#include <OgreCamera.h>`

Inheritance diagram for Ogre::Camera:
[legend]

## Classes
class | Listener
| Listener interface so you can be notified of Camera events. More...

## Public Member Functions
| Camera (const String &name, SceneManager *sm)
| Standard constructor.
virtual | ~Camera ()
| Standard destructor.
void | _autoTrack (void)
| Internal method used by OGRE to update auto-tracking cameras.
Real | _getLodBiasInverse (void) const
| Internal method for OGRE to use for LOD calculations.
unsigned int | _getNumRenderedBatches (void) const
| Internal method to retrieve the number of visible batches in the last render.
unsigned int | _getNumRenderedFaces (void) const
| Internal method to retrieve the number of visible faces in the last render.
void | _notifyRenderedBatches (unsigned int numbatches)
| Internal method to notify camera of the visible batches in the last render.
void | _notifyRenderedFaces (unsigned int numfaces)
| Internal method to notify camera of the visible faces in the last render.
void | _notifyViewport (Viewport *viewport)
| Notifies this camera that a viewport is using it.
void | _renderScene (Viewport *vp)
| Tells the Camera to contact the SceneManager to render from it's viewpoint.
void | _renderScene (Viewport *vp, bool unused)
virtual void | addListener (Listener *l)
| Add a listener to this camera.
virtual void | forwardIntersect (const Plane &worldPlane, std::vector< Vector4 > *intersect3d) const
| Forward projects frustum rays to find forward intersection with plane.
bool | getAutoAspectRatio (void) const
| Retrieves if AutoAspectRatio is currently set or not.
const Vector3 & | getAutoTrackOffset (void) const
| Get the auto tracking offset for this camera, if it is auto tracking.
SceneNode * | getAutoTrackTarget (void) const
| Get the auto tracking target for this camera, if any.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
PlaneBoundedVolume | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, bool includeFarPlane=false)
| Gets a world-space list of planes enclosing a volume based on a viewport rectangle.
void | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, PlaneBoundedVolume *outVolume, bool includeFarPlane=false)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Ray | getCameraToViewportRay (Real screenx, Real screeny) const
| Gets a world space ray as cast from the camera through a viewport position.
void | getCameraToViewportRay (Real screenx, Real screeny, Ray *outRay) const
| Gets a world space ray as cast from the camera through a viewport position.
Frustum * | getCullingFrustum (void) const
| Returns the custom culling frustum in use.
Vector3 | getDerivedDirection (void) const
| Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Quaternion & | getDerivedOrientation (void) const
| Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.
const Vector3 & | getDerivedPosition (void) const
| Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedRight (void) const
| Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDerivedUp (void) const
| Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.
Vector3 | getDirection (void) const
| Gets the camera's direction.
float | getFarClipDistance (void) const override
| Retrieves the distance from the frustum to the far clipping plane.
const Plane & | getFrustumPlane (unsigned short plane) const override
| Retrieves a specified plane of the frustum (world space).
Real | getLodBias (void) const
| Returns the level-of-detail bias factor currently applied to this camera.
virtual const Camera * | getLodCamera () const
| Get a pointer to the camera which should be used to determine LOD settings.
const String & | getMovableType (void) const override
| Returns the type name of this object.
float | getNearClipDistance (void) const override
| Retrieves the distance from the frustum to the near clipping plane.
const Quaternion & | getOrientation (void) const
| Returns the camera's current orientation.
const Quaternion & | getOrientationForViewUpdate (void) const override
| Get the derived orientation of this frustum.
Real | getPixelDisplayRatio () const
| Returns an estimated ratio between a pixel and the display area it represents.
PolygonMode | getPolygonMode (void) const
| Retrieves the level of detail that the camera will render.
const Vector3 & | getPosition (void) const
| Retrieves the camera's position.
const Vector3 & | getPositionForViewUpdate (void) const override
| Get the derived position of this frustum.
Vector3 | getRealDirection (void) const
| Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.
const Quaternion & | getRealOrientation (void) const
| Gets the real world orientation of the camera, including any rotation inherited from a node attachment.
const Vector3 & | getRealPosition (void) const
| Gets the real world position of the camera, including any translation inherited from a node attachment.
Vector3 | getRealRight (void) const
| Gets the real world right vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRealUp (void) const
| Gets the real world up vector of the camera, including any rotation inherited from a node attachment.
Vector3 | getRight (void) const
| Gets the camera's right vector.
SceneManager * | getSceneManager (void) const
| Returns a pointer to the SceneManager this camera is rendering through.
SortMode | getSortMode () const
| get the currently used SortMode
Vector3 | getUp (void) const
| Gets the camera's up vector.
bool | getUseMinPixelSize () const
| Returns whether to use min display size calculations.
virtual bool | getUseRenderingDistance (void) const
| Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
const Affine3 & | getViewMatrix (bool ownFrustumOnly) const
| Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.
const Affine3 & | getViewMatrix (void) const override
| Gets the view matrix for this frustum.
Viewport * | getViewport (void) const
| Get the last viewport which was attached to this camera.
const std::vector< Plane > & | getWindowPlanes (void) const
const Corners & | getWorldSpaceCorners (void) const override
| Gets the world space corners of the frustum.
bool | isVisible (const AxisAlignedBox &bound, FrustumPlane *culledBy=0) const override
| Tests whether the given container is visible in the Frustum.
bool | isVisible (const Sphere &bound, FrustumPlane *culledBy=0) const override
| Tests whether the given container is visible in the Frustum.
bool | isVisible (const Vector3 &vert, FrustumPlane *culledBy=0) const override
| Tests whether the given vertex is visible in the Frustum.
bool | isWindowSet (void) const
void | lookAt (const Vector3 &targetPoint)
| Points the camera at a location in worldspace.
void | lookAt (Real x, Real y, Real z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | move (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along world axes.
void | moveRelative (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).
void | pitch (const Radian &angle)
| Pitches the camera up/down anticlockwise around it's local z axis.
bool | projectSphere (const Sphere &sphere, Real *left, Real *top, Real *right, Real *bottom) const override
| Project a sphere onto the near plane and get the bounding rectangle.
virtual void | removeListener (Listener *l)
| Remove a listener to this camera.
void | resetWindow (void)
void | roll (const Radian &angle)
| Rolls the camera anticlockwise, around its local z axis.
void | rotate (const Quaternion &q)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | rotate (const Vector3 &axis, const Radian &angle)
| Rotate the camera around an arbitrary axis.
void | setAutoAspectRatio (bool autoratio)
| If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.
void | setAutoTracking (bool enabled, SceneNode *const target=0, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of a SceneNode.
void | setCullingFrustum (Frustum *frustum)
| Tells the camera to use a separate Frustum instance to perform culling.
void | setDirection (const Vector3 &vec)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setDirection (Real x, Real y, Real z)
| Sets the camera's direction vector.
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.
void | setLodBias (Real factor=1.0)
| Sets the level-of-detail factor for this Camera.
virtual void | setLodCamera (const Camera *lodCam)
| Set a pointer to the camera which should be used to determine LOD settings.
void | setOrientation (const Quaternion &q)
| Sets the camera's orientation.
void | setPolygonMode (PolygonMode sd)
| Sets the level of rendering detail required from this camera.
void | setPosition (const Vector3 &vec)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setPosition (Real x, Real y, Real z)
| Sets the camera's position.
void | setSortMode (SortMode sm)
| Set the function used to compute the camera-distance for sorting Renderables.
void | setUseMinPixelSize (bool enable)
| Sets whether to use min display size calculations.
virtual void | setUseRenderingDistance (bool use)
| Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.
void | setWindow (Real left, Real top, Real right, Real bottom)
virtual void | synchroniseBaseSettingsWith (const Camera *cam)
| Synchronise core camera settings with another.
void | yaw (const Radian &angle)
| Rotates the camera anticlockwise around it's local y axis.
Public Member Functions inherited from Ogre::Frustum
| Frustum (const String &name=BLANKSTRING)
| Named constructor.
virtual | ~Frustum ()
void | _notifyCurrentCamera (Camera *cam) override
| Internal method to notify the object of the camera to be used for the next rendering operation.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | calcViewMatrixRelative (const Vector3 &relPos, Matrix4 &matToUpdate) const
| Calculate a view matrix for this frustum, relative to a potentially dynamic point.
void | disableCustomNearClipPlane (void)
| Disables any custom near clip plane.
void | disableReflection (void)
| Disables reflection modification previously turned on with enableReflection.
void | enableCustomNearClipPlane (const MovablePlane *plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
void | enableCustomNearClipPlane (const Plane &plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
void | enableReflection (const MovablePlane *p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
void | enableReflection (const Plane &p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
Real | getAspectRatio (void) const
| Retrieves the current aspect ratio.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
const ColourValue & | getDebugColour () const
Real | getFocalLength () const
| Returns focal length of frustum.
const Radian & | getFOVy (void) const
| Retrieves the frustums Y-dimension Field Of View (FOV).
RealRect | getFrustumExtents () const
| Get the extents of the frustum in view space.
const Vector2 & | getFrustumOffset () const
| Retrieves the frustum offsets.
virtual const Plane * | getFrustumPlanes (void) const
| Retrieves the clipping planes of the frustum (world space).
const String & | getMovableType (void) const override
| Returns the type name of this object.
Real | getOrthoWindowHeight () const
| Gets the orthographic window height, for use with orthographic rendering only.
Real | getOrthoWindowWidth () const
| Gets the orthographic window width, for use with orthographic rendering only.
PlaneBoundedVolume | getPlaneBoundedVolume ()
| Gets a world-space list of planes enclosing the frustum.
const Matrix4 & | getProjectionMatrix (void) const
| Gets the normal projection matrix for this frustum.
const Matrix4 & | getProjectionMatrixWithRSDepth (void) const
| Gets the depth-adjusted projection matrix for the current rendersystem.
ProjectionType | getProjectionType (void) const
| Retrieves info on the type of projection used (orthographic or perspective).
const Affine3 & | getReflectionMatrix (void) const
| Returns the reflection matrix of the frustum if appropriate.
const Plane & | getReflectionPlane (void) const
| Returns the reflection plane of the frustum if appropriate.
uint32 | getTypeFlags (void) const override
| Get the 'type flags' for this MovableObject.
bool | isCustomNearClipPlaneEnabled (void) const
| Is a custom near clip plane in use?
bool | isCustomProjectionMatrixEnabled (void) const
| Returns whether a custom projection matrix is in use.
bool | isCustomViewMatrixEnabled (void) const
| Returns whether a custom view matrix is in use.
bool | isReflected (void) const
| Returns whether this frustum is being reflected.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
void | resetFrustumExtents ()
| Reset the frustum extents to be automatically derived from other params.
void | setAspectRatio (Real ratio)
| Sets the aspect ratio for the frustum viewport.
void | setCustomProjectionMatrix (bool enable, const Matrix4 &projectionMatrix=Matrix4::IDENTITY)
| Set whether to use a custom projection matrix on this frustum.
void | setCustomViewMatrix (bool enable, const Affine3 &viewMatrix=Affine3::IDENTITY)
| Set whether to use a custom view matrix on this frustum.
void | setDebugColour (const ColourValue &col)
void | setFarClipDistance (float farDist)
| Sets the distance to the far clipping plane.
void | setFocalLength (Real focalLength=1.0)
| Sets frustum focal length (used in stereo rendering).
void | setFOVy (const Radian &fovy)
| Sets the Y-dimension Field Of View (FOV) of the frustum.
void | setFrustumExtents (Real left, Real right, Real top, Real bottom)
| Manually set the extents of the frustum.
void | setFrustumOffset (const Vector2 &offset)
| Sets frustum offsets, used in stereo rendering.
void | setFrustumOffset (Real horizontal=0.0, Real vertical=0.0)
| Sets frustum offsets, used in stereo rendering.
void | setNearClipDistance (float nearDist)
| Sets the position of the near clipping plane.
void | setOrthoWindow (Real w, Real h)
| Sets the orthographic window settings, for use with orthographic rendering only.
void | setOrthoWindowHeight (Real h)
| Sets the orthographic window height, for use with orthographic rendering only.
void | setOrthoWindowWidth (Real w)
| Sets the orthographic window width, for use with orthographic rendering only.
virtual void | setProjectionType (ProjectionType pt)
| Sets the type of projection to use (orthographic or perspective).
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Additional Inherited Members
Public Types inherited from Ogre::Frustum
typedef Vector3 | Corners[8]
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
Static Public Attributes inherited from Ogre::Frustum
static const Real | INFINITE_FAR_PLANE_ADJUST
| Small constant used to reduce far plane projection to avoid inaccuracies.

## Detailed Description

A viewpoint from which the scene will be rendered.

OGRE renders scenes from a camera viewpoint into a buffer of some sort, normally a window or a texture (a subclass of RenderTarget). OGRE cameras support both perspective projection (the default, meaning objects get smaller the further away they are) and orthographic projection (blueprint-style, no decrease in size with distance). Each camera carries with it a style of rendering, e.g. full textured, flat shaded, wireframe), field of view, rendering distances etc, allowing you to use OGRE to create complex multi-window views if required. In addition, more than one camera can point at a single render target if required, each rendering to a subset of the target, allowing split screen and picture-in-picture views.

At render time, all Scene Objects will be transformed in the camera space, which is defined as:

- \(+x\) is right
- \(+y\) is up
- \(-z\) is away

Cameras maintain their own aspect ratios, field of view, and frustum, and project coordinates into normalised device coordinates measured from -1 to 1 in x and y, and 0 to 1 in z, where

- \(+x\) is right
- \(+y\) is up
- \(+z\) is away

At render time, the camera will be rendering to a Viewport which will translate these parametric coordinates into real screen coordinates. Obviously it is advisable that the viewport has the same aspect ratio as the camera to avoid distortion (unless you want it!).

## Constructor & Destructor Documentation

## ◆ Camera()

Ogre::Camera::Camera | ( | const String & | name,
|  | SceneManager * | sm )

Standard constructor.

Referenced by Ogre::Camera::Listener::cameraDestroyed(), Ogre::Camera::Listener::cameraPostRenderScene(), Ogre::Camera::Listener::cameraPreRenderScene(), getLodCamera(), operator<<, setLodCamera(), and synchroniseBaseSettingsWith().

## ◆ ~Camera()

virtual Ogre::Camera::~Camera | ( |  | ) |
| virtual

Standard destructor.

## Member Function Documentation

## ◆ addListener()

virtual void Ogre::Camera::addListener | ( | Listener * | l | ) |
| virtual

Add a listener to this camera.

## ◆ removeListener()

virtual void Ogre::Camera::removeListener | ( | Listener * | l | ) |
| virtual

Remove a listener to this camera.

## ◆ getSceneManager()

SceneManager * Ogre::Camera::getSceneManager | ( | void |  | ) | const

Returns a pointer to the SceneManager this camera is rendering through.

## ◆ setPolygonMode()

void Ogre::Camera::setPolygonMode | ( | PolygonMode | sd | ) |

Sets the level of rendering detail required from this camera.

Each camera is set to render at full detail by default, that is with full texturing, lighting etc. This method lets you change that behaviour, allowing you to make the camera just render a wireframe view, for example.

## ◆ getPolygonMode()

PolygonMode Ogre::Camera::getPolygonMode | ( | void |  | ) | const

Retrieves the level of detail that the camera will render.

## ◆ setPosition() [1/2]

void Ogre::Camera::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z )

Sets the camera's position.

Deprecated
  attach to SceneNode and use SceneNode::setPosition

## ◆ setPosition() [2/2]

void Ogre::Camera::setPosition | ( | const Vector3 & | vec | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::setPosition

## ◆ getPosition()

const Vector3 & Ogre::Camera::getPosition | ( | void |  | ) | const

Retrieves the camera's position.

Deprecated
  attach to SceneNode and use SceneNode::getPosition

## ◆ move()

void Ogre::Camera::move | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along world axes.

Deprecated
  attach to SceneNode and use SceneNode::translate

## ◆ moveRelative()

void Ogre::Camera::moveRelative | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).

Deprecated
  attach to SceneNode and use SceneNode::translate(vec, Node::TS_LOCAL)

## ◆ setDirection() [1/2]

void Ogre::Camera::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z )

Sets the camera's direction vector.

Note that the 'up' vector for the camera will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same).

Deprecated
  attach to SceneNode and use SceneNode::setDirection

## ◆ setDirection() [2/2]

void Ogre::Camera::setDirection | ( | const Vector3 & | vec | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::setDirection

## ◆ getDirection()

Vector3 Ogre::Camera::getDirection | ( | void |  | ) | const

Gets the camera's direction.

Deprecated
  attach to SceneNode and use SceneNode::getOrientation().zAxis() * -1

## ◆ getUp()

Vector3 Ogre::Camera::getUp | ( | void |  | ) | const

Gets the camera's up vector.

Deprecated
  attach to SceneNode and use SceneNode::getOrientation().yAxis()

## ◆ getRight()

Vector3 Ogre::Camera::getRight | ( | void |  | ) | const

Gets the camera's right vector.

Deprecated
  attach to SceneNode and use SceneNode::getOrientation().xAxis()

## ◆ lookAt() [1/2]

void Ogre::Camera::lookAt | ( | const Vector3 & | targetPoint | ) |

Points the camera at a location in worldspace.

This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point.

Parameters

  targetPoint | A vector specifying the look at point.

Deprecated
  attach to SceneNode and use SceneNode::lookAt

## ◆ lookAt() [2/2]

void Ogre::Camera::lookAt | ( | Real | x,
|  | Real | y,
|  | Real | z )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::lookAt

## ◆ roll()

void Ogre::Camera::roll | ( | const Radian & | angle | ) |

Rolls the camera anticlockwise, around its local z axis.

Deprecated
  attach to SceneNode and use SceneNode::roll

## ◆ yaw()

void Ogre::Camera::yaw | ( | const Radian & | angle | ) |

Rotates the camera anticlockwise around it's local y axis.

Deprecated
  attach to SceneNode and use SceneNode::yaw

## ◆ pitch()

void Ogre::Camera::pitch | ( | const Radian & | angle | ) |

Pitches the camera up/down anticlockwise around it's local z axis.

Deprecated
  attach to SceneNode and use SceneNode::pitch

## ◆ rotate() [1/2]

void Ogre::Camera::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle )

Rotate the camera around an arbitrary axis.

Deprecated
  attach to SceneNode and use SceneNode::rotate

## ◆ rotate() [2/2]

void Ogre::Camera::rotate | ( | const Quaternion & | q | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Deprecated
  attach to SceneNode and use SceneNode::rotate

## ◆ setFixedYawAxis()

void Ogre::Camera::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = Vector3::UNIT_Y )

Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.

This method allows you to change the yaw behaviour of the camera

- by default, the camera yaws around a fixed Y axis. This is often what you want - for example if you're making a first-person shooter, you really don't want the yaw axis to reflect the local camera Y, because this would mean a different yaw axis if the player is looking upwards rather than when they are looking straight ahead. You can change this behaviour by calling this method, which you will want to do if you are making a completely free camera like the kind used in a flight simulator.
  Parameters

    useFixed | If `true`, the axis passed in the second parameter will always be the yaw axis no matter what the camera orientation. If false, the camera yaws around the local Y.
    fixedAxis | The axis to use if the first parameter is true.

  Deprecated
    attach to SceneNode and use SceneNode::yaw(angle, Node::TS_PARENT)

## ◆ getOrientation()

const Quaternion & Ogre::Camera::getOrientation | ( | void |  | ) | const

Returns the camera's current orientation.

Deprecated
  attach to SceneNode and use SceneNode::getOrientation

## ◆ setOrientation()

void Ogre::Camera::setOrientation | ( | const Quaternion & | q | ) |

Sets the camera's orientation.

Deprecated
  attach to SceneNode and use SceneNode::setOrientation

## ◆ _autoTrack()

void Ogre::Camera::_autoTrack | ( | void |  | ) |

Internal method used by OGRE to update auto-tracking cameras.

## ◆ getAutoTrackTarget()

SceneNode * Ogre::Camera::getAutoTrackTarget | ( | void |  | ) | const
| inline

Get the auto tracking target for this camera, if any.

## ◆ getAutoTrackOffset()

const Vector3 & Ogre::Camera::getAutoTrackOffset | ( | void |  | ) | const
| inline

Get the auto tracking offset for this camera, if it is auto tracking.

## ◆ setAutoTracking()

void Ogre::Camera::setAutoTracking | ( | bool | enabled,
|  | SceneNode *const | target = 0,
|  | const Vector3 & | offset = Vector3::ZERO )

Enables / disables automatic tracking of a SceneNode.

If you enable auto-tracking, this Camera will automatically rotate to look at the target SceneNode every frame, no matter how it or SceneNode move. This is handy if you want a Camera to be focused on a single object or group of objects. Note that by default the Camera looks at the origin of the SceneNode, if you want to tweak this, e.g. if the object which is attached to this target node is quite big and you want to point the camera at a specific point on it, provide a vector in the 'offset' parameter and the camera's target point will be adjusted.

Parameters

  enabled | If true, the Camera will track the SceneNode supplied as the next parameter (cannot be null). If false the camera will cease tracking and will remain in it's current orientation.
  target | Pointer to the SceneNode which this Camera will track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  offset | If supplied, the camera targets this point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

Deprecated
  attach to SceneNode and use SceneNode::setAutoTracking

## ◆ getPositionForViewUpdate()

const Vector3 & Ogre::Camera::getPositionForViewUpdate | ( | void |  | ) | const
| overridevirtual

Get the derived position of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ getOrientationForViewUpdate()

const Quaternion & Ogre::Camera::getOrientationForViewUpdate | ( | void |  | ) | const
| overridevirtual

Get the derived orientation of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ _renderScene() [1/2]

void Ogre::Camera::_renderScene | ( | Viewport * | vp | ) |

Tells the Camera to contact the SceneManager to render from it's viewpoint.

Parameters

  vp | The viewport to render to

## ◆ _renderScene() [2/2]

void Ogre::Camera::_renderScene | ( | Viewport * | vp,
|  | bool | unused )
| inline

Deprecated
  do not use

References _renderScene().

Referenced by _renderScene().

## ◆ _notifyRenderedFaces()

void Ogre::Camera::_notifyRenderedFaces | ( | unsigned int | numfaces | ) |
| inline

Internal method to notify camera of the visible faces in the last render.

## ◆ _notifyRenderedBatches()

void Ogre::Camera::_notifyRenderedBatches | ( | unsigned int | numbatches | ) |
| inline

Internal method to notify camera of the visible batches in the last render.

## ◆ _getNumRenderedFaces()

unsigned int Ogre::Camera::_getNumRenderedFaces | ( | void |  | ) | const
| inline

Internal method to retrieve the number of visible faces in the last render.

## ◆ _getNumRenderedBatches()

unsigned int Ogre::Camera::_getNumRenderedBatches | ( | void |  | ) | const
| inline

Internal method to retrieve the number of visible batches in the last render.

## ◆ getDerivedOrientation()

const Quaternion & Ogre::Camera::getDerivedOrientation | ( | void |  | ) | const

Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedPosition()

const Vector3 & Ogre::Camera::getDerivedPosition | ( | void |  | ) | const

Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.

## ◆ getDerivedDirection()

Vector3 Ogre::Camera::getDerivedDirection | ( | void |  | ) | const

Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedUp()

Vector3 Ogre::Camera::getDerivedUp | ( | void |  | ) | const

Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedRight()

Vector3 Ogre::Camera::getDerivedRight | ( | void |  | ) | const

Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getRealOrientation()

const Quaternion & Ogre::Camera::getRealOrientation | ( | void |  | ) | const

Gets the real world orientation of the camera, including any rotation inherited from a node attachment.

## ◆ getRealPosition()

const Vector3 & Ogre::Camera::getRealPosition | ( | void |  | ) | const

Gets the real world position of the camera, including any translation inherited from a node attachment.

## ◆ getRealDirection()

Vector3 Ogre::Camera::getRealDirection | ( | void |  | ) | const

Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealUp()

Vector3 Ogre::Camera::getRealUp | ( | void |  | ) | const

Gets the real world up vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealRight()

Vector3 Ogre::Camera::getRealRight | ( | void |  | ) | const

Gets the real world right vector of the camera, including any rotation inherited from a node attachment.

## ◆ getMovableType()

const String & Ogre::Camera::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ setLodBias()

void Ogre::Camera::setLodBias | ( | Real | factor = 1.0 | ) |

Sets the level-of-detail factor for this Camera.

This method can be used to influence the overall level of detail of the scenes rendered using this camera. Various elements of the scene have level-of-detail reductions to improve rendering speed at distance; this method allows you to hint to those elements that you would like to adjust the level of detail that they would normally use (up or down).

  The most common use for this method is to reduce the overall level of detail used for a secondary camera used for sub viewports like rear-view mirrors etc. Note that scene elements are at liberty to ignore this setting if they choose, this is merely a hint.

Parameters

  factor | The factor to apply to the usual level of detail calculation. Higher values increase the detail, so 2.0 doubles the normal detail and 0.5 halves it.

## ◆ getLodBias()

Real Ogre::Camera::getLodBias | ( | void |  | ) | const

Returns the level-of-detail bias factor currently applied to this camera.

See Camera::setLodBias for more details.

## ◆ setLodCamera()

virtual void Ogre::Camera::setLodCamera | ( | const Camera * | lodCam | ) |
| virtual

Set a pointer to the camera which should be used to determine LOD settings.

Sometimes you don't want the LOD of a render to be based on the camera that's doing the rendering, you want it to be based on a different camera. A good example is when rendering shadow maps, since they will be viewed from the perspective of another camera. Therefore this method lets you associate a different camera instance to use to determine the LOD.

  To revert the camera to determining LOD based on itself, call this method with a pointer to itself.

References Camera().

## ◆ getLodCamera()

virtual const Camera * Ogre::Camera::getLodCamera | ( |  | ) | const
| virtual

Get a pointer to the camera which should be used to determine LOD settings.

If setLodCamera hasn't been called with a different camera, this method will return 'this'.

References Camera().

## ◆ getCameraToViewportRay() [1/2]

Ray Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny ) const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]

## ◆ getCameraToViewportRay() [2/2]

void Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny,
|  | Ray * | outRay ) const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]
  outRay | Ray instance to populate with result

## ◆ getCameraToViewportBoxVolume() [1/2]

PlaneBoundedVolume Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | bool | includeFarPlane = false )

Gets a world-space list of planes enclosing a volume based on a viewport rectangle.

Can be useful for populating a PlaneBoundedVolumeListSceneQuery, e.g. for a rubber-band selection.

Parameters

  screenLeft,screenTop,screenRight,screenBottom | The bounds of the on-screen rectangle, expressed in normalised screen coordinates [0,1]
  includeFarPlane | If true, the volume is truncated by the camera far plane, by default it is left open-ended

## ◆ getCameraToViewportBoxVolume() [2/2]

void Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | PlaneBoundedVolume * | outVolume,
|  | bool | includeFarPlane = false )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ _getLodBiasInverse()

Real Ogre::Camera::_getLodBiasInverse | ( | void |  | ) | const

Internal method for OGRE to use for LOD calculations.

## ◆ setWindow()

void Ogre::Camera::setWindow | ( | Real | left,
|  | Real | top,
|  | Real | right,
|  | Real | bottom )

Deprecated
  use RenderSystem::setScissorTest instead

## ◆ resetWindow()

void Ogre::Camera::resetWindow | ( | void |  | ) |

Deprecated
  do not use

## ◆ isWindowSet()

bool Ogre::Camera::isWindowSet | ( | void |  | ) | const
| inline

Deprecated
  do not use

## ◆ getWindowPlanes()

const std::vector< Plane > & Ogre::Camera::getWindowPlanes | ( | void |  | ) | const

Deprecated
  do not use

## ◆ getBoundingRadius()

Real Ogre::Camera::getBoundingRadius | ( | void |  | ) | const
| overridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ getViewport()

Viewport * Ogre::Camera::getViewport | ( | void |  | ) | const
| inline

Get the last viewport which was attached to this camera.

Note
  This is not guaranteed to be the only viewport which is using this camera, just the last once which was created referring to it.

## ◆ _notifyViewport()

void Ogre::Camera::_notifyViewport | ( | Viewport * | viewport | ) |
| inline

Notifies this camera that a viewport is using it.

## ◆ setAutoAspectRatio()

void Ogre::Camera::setAutoAspectRatio | ( | bool | autoratio | ) |

If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.

You should set this to true only if the frustum / camera is used by one viewport at the same time. Otherwise the aspect ratio for other viewports may be wrong.

## ◆ getAutoAspectRatio()

bool Ogre::Camera::getAutoAspectRatio | ( | void |  | ) | const

Retrieves if AutoAspectRatio is currently set or not.

## ◆ setCullingFrustum()

void Ogre::Camera::setCullingFrustum | ( | Frustum * | frustum | ) |
| inline

Tells the camera to use a separate Frustum instance to perform culling.

By calling this method, you can tell the camera to perform culling against a different frustum to it's own. This is mostly useful for debug cameras that allow you to show the culling behaviour of another camera, or a manual frustum instance.

Parameters

  frustum | Pointer to a frustum to use; this can either be a manual Frustum instance (which you can attach to scene nodes like any other MovableObject), or another camera. If you pass 0 to this method it reverts the camera to normal behaviour.

References Ogre::Frustum::Frustum().

## ◆ getCullingFrustum()

Frustum * Ogre::Camera::getCullingFrustum | ( | void |  | ) | const
| inline

Returns the custom culling frustum in use.

References Ogre::Frustum::Frustum().

## ◆ forwardIntersect()

virtual void Ogre::Camera::forwardIntersect | ( | const Plane & | worldPlane,
|  | std::vector< Vector4 > * | intersect3d ) const
| virtual

Forward projects frustum rays to find forward intersection with plane.

Forward projection may lead to intersections at infinity.

## ◆ isVisible() [1/3]

bool Ogre::Camera::isVisible | ( | const AxisAlignedBox & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding box to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the box was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

Reimplemented in Ogre::PCZCamera.

## ◆ isVisible() [2/3]

bool Ogre::Camera::isVisible | ( | const Sphere & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding sphere to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [3/3]

bool Ogre::Camera::isVisible | ( | const Vector3 & | vert,
|  | FrustumPlane * | culledBy = 0 ) const
| overridevirtual

Tests whether the given vertex is visible in the Frustum.

Parameters

  vert | Vertex to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ getWorldSpaceCorners()

const Corners & Ogre::Camera::getWorldSpaceCorners | ( | void |  | ) | const
| overridevirtual

Gets the world space corners of the frustum.

The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far.

Reimplemented from Ogre::Frustum.

## ◆ getFrustumPlane()

const Plane & Ogre::Camera::getFrustumPlane | ( | unsigned short | plane | ) | const
| overridevirtual

Retrieves a specified plane of the frustum (world space).

Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes.

Reimplemented from Ogre::Frustum.

## ◆ projectSphere()

bool Ogre::Camera::projectSphere | ( | const Sphere & | sphere,
|  | Real * | left,
|  | Real * | top,
|  | Real * | right,
|  | Real * | bottom ) const
| overridevirtual

Project a sphere onto the near plane and get the bounding rectangle.

Parameters

  sphere | The world-space sphere to project.
  left | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  top | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  right | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).

Returns
  `true` if the sphere was projected to a subset of the near plane, `false` if the entire near plane was contained.

Reimplemented from Ogre::Frustum.

## ◆ getNearClipDistance()

float Ogre::Camera::getNearClipDistance | ( | void |  | ) | const
| overridevirtual

Retrieves the distance from the frustum to the near clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getFarClipDistance()

float Ogre::Camera::getFarClipDistance | ( | void |  | ) | const
| overridevirtual

Retrieves the distance from the frustum to the far clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getViewMatrix() [1/2]

const Affine3 & Ogre::Camera::getViewMatrix | ( | void |  | ) | const
| overridevirtual

Gets the view matrix for this frustum.

Mainly for use by OGRE internally.

Reimplemented from Ogre::Frustum.

## ◆ getViewMatrix() [2/2]

const Affine3 & Ogre::Camera::getViewMatrix | ( | bool | ownFrustumOnly | ) | const

Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.

The default behaviour of the standard getViewMatrix is to delegate to the alternate culling frustum, if it is set. This is expected when performing CPU calculations, but the final rendering must be performed using the real view matrix in order to display the correct debug view.

## ◆ setUseRenderingDistance()

virtual void Ogre::Camera::setUseRenderingDistance | ( | bool | use | ) |
| inlinevirtual

Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

The default behaviour is to use it.

Parameters

  use | True to use the rendering distance, false not to.

## ◆ getUseRenderingDistance()

virtual bool Ogre::Camera::getUseRenderingDistance | ( | void |  | ) | const
| inlinevirtual

Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

## ◆ synchroniseBaseSettingsWith()

virtual void Ogre::Camera::synchroniseBaseSettingsWith | ( | const Camera * | cam | ) |
| virtual

Synchronise core camera settings with another.

Copies the position, orientation, clip distances, projection type, FOV, focal length and aspect ratio from another camera. Other settings like query flags, reflection etc are preserved.

References Camera().

## ◆ setUseMinPixelSize()

void Ogre::Camera::setUseMinPixelSize | ( | bool | enable | ) |
| inline

Sets whether to use min display size calculations.

When active, objects that derive from MovableObject whose size on the screen is less then a MovableObject::mMinPixelSize will not be rendered.

## ◆ getUseMinPixelSize()

bool Ogre::Camera::getUseMinPixelSize | ( |  | ) | const
| inline

Returns whether to use min display size calculations.

See also
  Camera::setUseMinDisplaySize

## ◆ getPixelDisplayRatio()

Real Ogre::Camera::getPixelDisplayRatio | ( |  | ) | const
| inline

Returns an estimated ratio between a pixel and the display area it represents.

For orthographic cameras this function returns the amount of meters covered by a single pixel along the vertical axis. For perspective cameras the value returned is the amount of meters covered by a single pixel per meter distance from the camera.

Note
  This parameter is calculated just before the camera is rendered
  This parameter is used in min display size calculations.

## ◆ setSortMode()

void Ogre::Camera::setSortMode | ( | SortMode | sm | ) |
| inline

Set the function used to compute the camera-distance for sorting Renderables.

## ◆ getSortMode()

SortMode Ogre::Camera::getSortMode | ( |  | ) | const
| inline

get the currently used SortMode

The documentation for this class was generated from the following file:

- OgreCamera.h